## cdogs-sdl 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
cmake_policy(SET CMP0054 NEW)
cmake_policy(SET CMP0072 NEW)
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9)
set(CMAKE_OSX_ARCHITECTURES x86_64)
project(cdogs-sdl C)

SET(VERSION_MAJOR "1")
SET(VERSION_MINOR "3")
SET(VERSION_PATCH "1")
SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

# Optionally configure CI files since they are excluded in source archives
if(EXISTS ${CMAKE_SOURCE_DIR}/.github/workflows/cmake.yml.cmake)
	CONFIGURE_FILE(
		${CMAKE_SOURCE_DIR}/.github/workflows/cmake.yml.cmake
		${CMAKE_SOURCE_DIR}/.github/workflows/cmake.yml
		@ONLY
	)
endif()
if(EXISTS ${CMAKE_SOURCE_DIR}/appveyor.yml.cmake)
	CONFIGURE_FILE(
		${CMAKE_SOURCE_DIR}/appveyor.yml.cmake
		${CMAKE_SOURCE_DIR}/appveyor.yml
		@ONLY
	)
endif()

# this must be 4 numbers
SET(VERSION_RC "${VERSION_MAJOR},${VERSION_MINOR},${VERSION_PATCH},0")
SET(WEBSITE "http://cxong.github.io/cdogs-sdl/")

option(DEBUG "Enable debug build" OFF)
option(DEBUG_PROFILE "Enable debug profile build" OFF)
option(USE_SHARED_ENET "Use system installed copy of enet" OFF)
option(BUILD_EDITOR "Build cdogs-sdl-editor" ON)

# check for crosscompiling (defined when using a toolchain file)
if(CMAKE_CROSSCOMPILING)
	# check for gcw0
	if(CMAKE_C_COMPILER MATCHES ".*gcw0-linux.*")
		set(GCW0 1)
		set(BUILD_EDITOR OFF)
	endif()
endif()

if(CMAKE_C_COMPILER_ID MATCHES "Clang")
	set(CLANG 1)
endif()

if(WIN32)
	set(CMAKE_RC_COMPILER_INIT windres)
	enable_language(RC)
	SET(CMAKE_RC_COMPILE_OBJECT
		"<CMAKE_RC_COMPILER> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
endif()
SET(LINKDIR /usr/games)

if(DEBUG)
	set(CMAKE_BUILD_TYPE "Debug")
else()
	add_definitions(-DNDEBUG)
endif()

set(CMAKE_MODULE_PATH
	${CMAKE_MODULE_PATH}
	"${CMAKE_SOURCE_DIR}/build/cmake"
	"${CMAKE_SOURCE_DIR}/src/proto/nanopb/extra")
	
find_package(Nanopb REQUIRED)
find_package(SDL2 REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_mixer REQUIRED)
if(BUILD_EDITOR)
	find_package(OpenGL REQUIRED)
endif()
find_package(CCache)
link_directories(${SDL2_LIBRARY_DIRS} ${SDL2_IMAGE_LIBRARY_DIRS} ${SDL2_MIXER_LIBRARY_DIRS})

if(CCACHE_FOUND AND CLANG)
	add_definitions(-Qunused-arguments -fcolor-diagnostics)
endif()

SET(ENet_LIBRARY enet)
IF(WIN32)
    SET(WINDOWS_ENET_DEPENDENCIES "ws2_32;winmm")
    SET(ENet_LIBRARIES ${ENet_LIBRARY} ${WINDOWS_ENET_DEPENDENCIES})
ELSE()
    SET(ENet_LIBRARIES ${ENet_LIBRARY})
ENDIF()

IF(NOT USE_SHARED_ENET)
    INCLUDE_DIRECTORIES(src/cdogs/enet/include)
ENDIF()

if(MSVC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -MP -W4 -WX -wd\"4996\" -wd\"4204\"")
else()
	add_definitions(
		-fsigned-char
		-Wall -W
		-Wstrict-prototypes -Wpointer-arith -Wcast-qual)
	if(DEBUG)
		ADD_DEFINITIONS(-g)
		if(DEBUG_PROFILE AND CMAKE_COMPILER_IS_GNUCC)
			ADD_DEFINITIONS(-p)
		endif()
	else()
		ADD_DEFINITIONS(-O2)
	endif()
	if(GCW0)
		add_definitions(-D__GCWZERO__)
	endif()
    if(CLANG)
		add_definitions(-std=gnu99)

		if(${CMAKE_C_COMPILER_VERSION} VERSION_GREATER_EQUAL 13.1)
			# TODO: used by nuklear
			add_definitions(-Wno-null-pointer-arithmetic -Wno-null-pointer-subtraction)
		endif()
    else()
        # Probably GCC...
        add_definitions(-freg-struct-return -std=gnu99)
		if(NOT APPLE AND NOT BEOS AND NOT HAIKU)
			add_definitions(-Wshadow)
		endif()
		if (CMAKE_C_COMPILER_VERSION VERSION_GREATER 7)
			add_definitions(
				-Wimplicit-fallthrough=0 # TODO: is everything caught by implicit-fallthrough intended?
				-Wno-error=format-overflow # TODO: should probably just make sure buffer sizes are appropriate
			)
		endif()
	endif()
	if(NOT BEOS AND NOT HAIKU)
		add_definitions(-Winline -Werror)
		set(EXTRA_LIBRARIES "m")
	endif()
endif()

set(CMAKE_MACOSX_RPATH 1)

if(NOT DEFINED CDOGS_DATA_DIR)
	if(GCW0)
		set(CDOGS_DATA_DIR "./")
	else()
		set(CDOGS_DATA_DIR "../")
	endif()
endif()
message("Data dir is ${CDOGS_DATA_DIR}")
if(WIN32)
	set(CDOGS_CFG_DIR "C-Dogs SDL/")
else()
	set(CDOGS_CFG_DIR ".config/cdogs-sdl/")
ENDIF()
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ".")
IF(UNIX AND NOT APPLE)
	CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/build/linux/cdogs-sdl.cmake ${CMAKE_SOURCE_DIR}/build/linux/cdogs-sdl)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/build/linux/cdogs-sdl PROPERTIES GENERATED TRUE)
ENDIF()
IF(WIN32)
	CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/build/windows/cdogs.rc.cmake ${CMAKE_SOURCE_DIR}/build/windows/cdogs.rc)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/build/windows/cdogs.rc PROPERTIES GENERATED TRUE)
ENDIF()
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/src/cdogs/sys_config.h.cmake ${CMAKE_SOURCE_DIR}/src/cdogs/sys_config.h)
SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/src/cdogs/sys_config.h PROPERTIES GENERATED TRUE)
include_directories(src src/cdogs)

# Tests
enable_testing()

add_subdirectory(src)

# Build the shared library next to cdogs-sdl
set_target_properties(cdogs-sdl PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_CURRENT_BINARY_DIR}/src
	RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_CURRENT_BINARY_DIR}/src
)
if(BUILD_EDITOR)
	set_target_properties(cdogs-sdl-editor PROPERTIES
		RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_CURRENT_BINARY_DIR}/src
		RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_CURRENT_BINARY_DIR}/src
	)
endif()

################
# Installation #
################

# Executables
set(INSTALL_PREFIX ".")
set(EXE_EXTENSION "")
if(WIN32)
	set(EXE_EXTENSION ".exe")
	set(LIB_EXTENSION ".dll")
  set(DATA_INSTALL_DIR ".")
elseif(APPLE)
	set(LIB_EXTENSION ".dylib")
  set(DATA_INSTALL_DIR "cdogs-sdl")
	set(INSTALL_PREFIX "cdogs-sdl")
else()
	set(LIB_EXTENSION ".so")
	set(DATA_INSTALL_DIR ".")
endif()

# Since Debian wants games binaries in /usr/games
if(NOT DEFINED CDOGS_BIN_DIR)
	set(CDOGS_BIN_DIR "${INSTALL_PREFIX}/bin")
endif()

install(
  PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/src/cdogs-sdl${EXE_EXTENSION}
    DESTINATION ${CDOGS_BIN_DIR})
if(BUILD_EDITOR)
	install(
	  PROGRAMS
	    ${CMAKE_CURRENT_BINARY_DIR}/src/cdogs-sdl-editor${EXE_EXTENSION}
	    DESTINATION ${CDOGS_BIN_DIR})
endif()

INSTALL(DIRECTORY
	${CMAKE_SOURCE_DIR}/data
	${CMAKE_SOURCE_DIR}/missions
	${CMAKE_SOURCE_DIR}/dogfights
	${CMAKE_SOURCE_DIR}/graphics
	${CMAKE_SOURCE_DIR}/music
	${CMAKE_SOURCE_DIR}/sounds
	DESTINATION ${DATA_INSTALL_DIR})

if(NOT DEFINED CDOGS_DOC_DIR)
	set(CDOGS_DOC_DIR "${DATA_INSTALL_DIR}/doc")
endif()
INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/
	DESTINATION ${CDOGS_DOC_DIR}
	)

INSTALL(FILES
	${CMAKE_SOURCE_DIR}/README.md
	DESTINATION ${DATA_INSTALL_DIR})
IF(UNIX AND NOT APPLE AND NOT BEOS AND NOT HAIKU)
	INSTALL(FILES ${CMAKE_SOURCE_DIR}/build/linux/io.github.cxong.cdogs-sdl.desktop DESTINATION ${INSTALL_PREFIX}/share/applications)
	INSTALL(FILES ${CMAKE_SOURCE_DIR}/build/linux/io.github.cxong.cdogs-sdl.appdata.xml DESTINATION ${INSTALL_PREFIX}/share/metainfo)
	foreach(RES 16 22 32 48 128)
		INSTALL(FILES ${CMAKE_SOURCE_DIR}/build/linux/cdogs-icon.${RES}.png
			DESTINATION ${INSTALL_PREFIX}/share/icons/hicolor/${RES}x${RES}/apps
			RENAME io.github.cxong.cdogs-sdl.png)
	endforeach(RES)
elseif(WIN32)
	# Package for Windows
	FILE(GLOB DLLS "${CMAKE_SOURCE_DIR}/dll/*.dll")
	FOREACH(DLL ${DLLS})
		INSTALL(FILES "${DLL}" DESTINATION ${INSTALL_PREFIX}/bin)
	ENDFOREACH()
	install(DIRECTORY ${CMAKE_SOURCE_DIR}/build/licenses DESTINATION ${INSTALL_PREFIX})
elseif(APPLE)
	set(CMAKE_INSTALL_PREFIX "/Applications/cdogs-sdl")
endif()

# Packaging
SET(CPACK_PACKAGE_NAME "C-Dogs.SDL")
SET(CPACK_PACKAGE_VENDOR "C-Dogs SDL Team")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "C-Dogs SDL: Action/Arcade Game")
SET(CPACK_PACKAGE_VERSION ${VERSION})
SET(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
SET(CPACK_PACKAGE_EXECUTABLES "cdogs-sdl;C-Dogs SDL;cdogs-sdl-editor;Campaign Editor")
if(WIN32)
	SET(CPACK_GENERATOR NSIS ZIP)
	SET(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL ON)
	SET(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/doc/COPYING.GPL)
	set(CPACK_PACKAGE_INSTALL_DIRECTORY "C-Dogs SDL")
	SET(CPACK_NSIS_MUI_ICON ${CMAKE_SOURCE_DIR}/build/windows/cdogs-icon.ico)
	set(CPACK_NSIS_CREATE_ICONS "SetOutPath '\$INSTDIR\\\\bin'
	CreateShortCut '\$SMPROGRAMS\\\\$STARTMENU_FOLDER\\\\C-Dogs SDL.lnk' '\$INSTDIR\\\\bin\\\\cdogs-sdl.exe'
	CreateShortCut '\$SMPROGRAMS\\\\$STARTMENU_FOLDER\\\\Campaign Editor.lnk' '\$INSTDIR\\\\bin\\\\cdogs-sdl-editor.exe'")
	SET(CPACK_NSIS_MUI_FINISHPAGE_RUN cdogs-sdl.exe)
	SET(CPACK_NSIS_URL_INFO_ABOUT ${WEBSITE})
elseif(APPLE)
	set(CPACK_GENERATOR "DragNDrop")
	set(CPACK_DMG_FORMAT "UDBZ")
	set(CPACK_DMG_VOLUME_NAME "C-Dogs.SDL")
	set(CPACK_SYSTEM_NAME "OSX")
	set(CPACK_PACKAGE_ICON
		"${CMAKE_SOURCE_DIR}/build/macosx/cdogs-icon.icns")
	set(CPACK_DMG_BACKGROUND_IMAGE
		"${CMAKE_SOURCE_DIR}/build/macosx/dmg_bg.png")
	set(CPACK_DMG_DS_STORE
		"${CMAKE_SOURCE_DIR}/build/macosx/DS_Store")

	# copy SDL frameworks
	set(APPS cdogs-sdl cdogs-sdl-editor)
	set(LIBS SDL2 SDL2_image SDL2_mixer)
	foreach(APP ${APPS})
		foreach(LIB ${LIBS})
			install(DIRECTORY /Library/Frameworks/${LIB}.framework
				DESTINATION ${INSTALL_PREFIX}/Frameworks)
		endforeach()
	endforeach()
elseif(BEOS OR HAIKU)
	set(CPACK_GENERATOR TGZ)
	install(
		FILES ${CMAKE_SOURCE_DIR}/build/haiku/cdogs-sdl.sh
		DESTINATION ${INSTALL_PREFIX}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
else()
	# probably linux

	# Pack only tar.gz since deb and rpm packages may differ in distros
	set(CPACK_GENERATOR TGZ)

	# debian specific
	set(CPACK_DEBIAN_PACKAGE_MAINTAINER "C-Dogs SDL Team")
	set(CPACK_DEBIAN_PACKAGE_SECTION Games)
	set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6, libsdl2-image, libsdl2-mixer")

	# fedora/suse specific
	set(CPACK_RPM_PACKAGE_LICENSE "GPL2")
	set(CPACK_RPM_PACKAGE_GROUP "Amusements/Games/Action/Arcade")
	set(CPACK_RPM_PACKAGE_REQUIRES "sdl_image >= 2, sdl_mixer >= 2")

endif()
include(CPack)

=== src/CMakeLists.txt ===
include_directories(
	.
	proto/nanopb
	${SDL2_INCLUDE_DIRS}
	${SDL2_IMAGE_INCLUDE_DIRS}
	${SDL2_MIXER_INCLUDE_DIRS})
if(BUILD_EDITOR)
	include_directories(${OPENGL_INCLUDE_DIRS})
endif()

add_subdirectory(cdogs)
if(BUILD_EDITOR)
	add_subdirectory(cdogsed)
endif()
add_subdirectory(json)
add_subdirectory(proto)
add_subdirectory(tests)

set(CDOGS_SDL_SOURCES
	animated_counter.c
	autosave.c
	briefing_screens.c
	cdogs.c
	command_line.c
	credits.c
	game.c
	game_loop.c
	hiscores.c
	loading_screens.c
	mainmenu.c
	menu.c
	menu_utils.c
	namegen.c
	password.c
	player_select_menus.c
	prep.c
	prep_equip.c
	screens_end.c
	weapon_menu.c)
set(CDOGS_SDL_HEADERS
	animated_counter.h
	autosave.h
	briefing_screens.h
	command_line.h
	credits.h
	game.h
	game_loop.h
	hiscores.h
	loading_screens.h
	mainmenu.h
	menu.h
	menu_utils.h
	namegen.h
	password.h
	player_select_menus.h
	prep.h
	prep_equip.h
	screens_end.h
	weapon_menu.h)
set(CDOGS_SDL_EXTRA)
if(WIN32)
	set(CDOGS_SDL_EXTRA ../build/windows/cdogs.rc)
elseif(APPLE)
	set(EXTRA_LIBRARIES "${EXTRA_LIBRARIES} -framework Carbon -framework IOKit")
endif()
add_executable(cdogs-sdl
	${CDOGS_SDL_SOURCES} ${CDOGS_SDL_HEADERS} ${CDOGS_SDL_EXTRA})
if(APPLE)
	set_target_properties(cdogs-sdl PROPERTIES
		MACOSX_RPATH 1
		BUILD_WITH_INSTALL_RPATH 1
		INSTALL_RPATH "@loader_path/../Frameworks")
elseif(MSVC)
	set_target_properties(cdogs-sdl PROPERTIES VS_DEBUGGER_WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/src")
endif()
target_link_libraries(cdogs-sdl cdogs cdogs_proto ${EXTRA_LIBRARIES})

if(GCW0)
	add_custom_command(TARGET cdogs-sdl
		POST_BUILD
		COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../build/gcw-zero/make_opk.sh ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/..
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/..
		COMMENT "Building cdogs-sdl.opk..."
	)
endif()

if(BUILD_EDITOR)
  add_executable(cdogs-sdl-editor cdogsed/cdogsed.c ${CDOGS_SDL_EXTRA})
  if(APPLE)
  	set_target_properties(cdogs-sdl-editor PROPERTIES
  		MACOSX_RPATH 1
  		BUILD_WITH_INSTALL_RPATH 1
  		INSTALL_RPATH "@loader_path/../Frameworks")
  elseif(MSVC)
  	set_target_properties(cdogs-sdl-editor PROPERTIES VS_DEBUGGER_WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/src")
  endif()
  target_link_libraries(cdogs-sdl-editor cdogsedlib cdogs cdogs_proto ${OPENGL_LIBRARIES} ${EXTRA_LIBRARIES})
endif()

=== src/cdogs/CMakeLists.txt ===
include_directories(
	.. # to include proto
	${SDL2_INCLUDE_DIRS}
	${SDL2_IMAGE_INCLUDE_DIRS}
	${SDL2_MIXER_INCLUDE_DIRS})
add_definitions(-DSTATIC)
set(CDOGS_SOURCES
	actor_fire.c
	actor_placement.c
	actors.c
	aheasing/easing.c
	ai.c
	ai_context.c
	ai_coop.c
	ai_utils.c
	algorithms.c
	ammo.c
	animation.c
	AStar.c
	automap.c
	blit.c
	bullet_class.c
	c_array.c
	camera.c
	campaign_entry.c
	campaigns.c
	character.c
	character_class.c
	collision/collision.c
	collision/minkowski_hex.c
	color.c
	config.c
	config_apply.c
	config_io.c
	config_json.c
	config_old.c
	cpic.c
	damage.c
	defs.c
	door.c
	draw/char_sprites.c
	draw/draw.c
	draw/draw_actor.c
	draw/draw_buffer.c
	draw/drawtools.c
	draw/nine_slice.c
	emitter.c
	events.c
	files.c
	font.c
	font_utils.c
	game_events.c
	game_mode.c
	gamedata.c
	grafx.c
	grafx_bg.c
	handle_game_events.c
	hud/fps.c
	hud/gauge.c
	hud/health_gauge.c
	hud/hud.c
	hud/hud_num_popup.c
	hud/player_hud.c
	hud/wall_clock.c
	joystick.c
	json_utils.c
	keyboard.c
	log.c
	los.c
	map.c
	map_archive.c
	map_build.c
	map_cave.c
	map_classic.c
	map_interior.c
	map_new.c
	map_object.c
	map_static.c
	map_wolf.c
	material.c
	mathc/mathc.c
	mission.c
	mission_convert.c
	mission_static.c
	mouse.c
	music.c
	net_client.c
	net_server.c
	net_util.c
	objective.c
	objs.c
	palette.c
	particle.c
	path_cache.c
	pic.c
	pic_manager.c
	pickup.c
	pickup_class.c
	pics.c
	player.c
	player_template.c
	powerup.c
	quick_play.c
	screen_shake.c
	sounds.c
	texture.c
	thing.c
	tile.c
	tile_class.c
	triggers.c
	utils.c
	vector.c
	weapon.c
	weapon_class.c
	window_context.c
	XGetopt.c
	yajl_utils.c)
set(CDOGS_HEADERS
	actor_fire.h
	actor_placement.h
	actors.h
	aheasing/easing.h
	ai.h
	ai_context.h
	ai_coop.h
	ai_utils.h
	algorithms.h
	ammo.h
	animation.h
	AStar.h
	automap.h
	blit.h
	bullet_class.h
	c_array.h
	camera.h
	campaign_entry.h
	campaigns.h
	character.h
	character_class.h
	collision/collision.h
	collision/minkowski_hex.h
	color.h
	config.h
	config_io.h
	config_json.h
	config_old.h
	cpic.h
	damage.h
	defs.h
	door.h
	draw/char_sprites.h
	draw/draw.h
	draw/draw_actor.h
	draw/draw_buffer.h
	draw/drawtools.h
	draw/nine_slice.h
	emitter.h
	events.h
	files.h
	font.h
	font_utils.h
	game_events.h
	game_mode.h
	gamedata.h
	grafx.h
	grafx_bg.h
	handle_game_events.h
	hud/fps.h
	hud/gauge.h
	hud/health_gauge.h
	hud/hud.h
	hud/hud_defs.h
	hud/hud_num_popup.h
	hud/player_hud.h
	hud/wall_clock.h
	joystick.h
	json_utils.h
	keyboard.h
	log.h
	los.h
	map.h
	map_archive.h
	map_build.h
	map_cave.h
	map_classic.h
	map_interior.h
	map_new.h
	map_object.h
	map_static.h
	map_wolf.h
	material.h
	mathc/mathc.h
	mission.h
	mission_convert.h
	mission_static.h
	mouse.h
	music.h
	net_client.h
	net_server.h
	net_util.h
	objective.h
	objs.h
	palette.h
	particle.h
	path_cache.h
	pic.h
	pic_manager.h
	pickup.h
	pickup_class.h
	pics.h
	player.h
	player_template.h
	powerup.h
	quick_play.h
	screen_shake.h
	sounds.h
	sys_config.h
	sys_specifics.h
	texture.h
	thing.h
	tile.h
	tile_class.h
	triggers.h
	utils.h
	vector.h
	weapon.h
	weapon_class.h
	window_context.h
	XGetopt.h
	yajl_utils.h)

IF(NOT USE_SHARED_ENET)
    ADD_SUBDIRECTORY(enet)
ENDIF()

add_subdirectory(c_hashmap)
add_subdirectory(cwolfmap)
add_subdirectory(SDL_JoystickButtonNames)
add_subdirectory(yajl)

add_library(cdogs STATIC
	${CDOGS_SOURCES} ${CDOGS_HEADERS})

target_link_libraries(cdogs
	c_hashmap
	cwolfmap
	json
	SDL_joystickbuttonnames
	yajl_s
	${SDL2_LIBRARY}
	${SDL2_IMAGE_LIBRARIES}
	${SDL2_MIXER_LIBRARIES}
	${ENet_LIBRARIES})

=== src/cdogsed/CMakeLists.txt ===
add_subdirectory(osdialog)
include_directories(
	${SDL2_INCLUDE_DIRS}
	${SDL2_IMAGE_INCLUDE_DIRS}
	${SDL2_MIXER_INCLUDE_DIRS})
set(CDOGSED_SOURCES
	add_pickup_dialog.c
	campaign_options.c
	char_editor.c
	editor_brush.c
	editor_ui.c
	editor_ui_cave.c
	editor_ui_classic.c
	editor_ui_color.c
	editor_ui_common.c
	editor_ui_interior.c
	editor_ui_objectives.c
	editor_ui_static.c
	editor_ui_static_additem.c
	editor_ui_weapons.c
	exit_brush.c
	mission_options.c
	nk_window.c
	tile_brush.c
	ui_object.c)
set(CDOGSED_HEADERS
	add_pickup_dialog.h
	campaign_options.h
	char_editor.h
	editor_brush.h
	editor_ui.h
	editor_ui_cave.h
	editor_ui_classic.h
	editor_ui_color.h
	editor_ui_common.h
	editor_ui_interior.h
	editor_ui_objectives.h
	editor_ui_static.h
	editor_ui_static_additem.h
	editor_ui_weapons.h
	exit_brush.h
	mission_options.h
	nk_window.h
	tile_brush.h
	ui_object.h)
add_library(cdogsedlib STATIC ${CDOGSED_SOURCES} ${CDOGSED_HEADERS})
target_link_libraries(cdogsedlib
	${SDL2_LIBRARY} osdialog)

=== src/cdogsed/osdialog/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(osdialog C)

set(SOURCES osdialog.c osdialog.h)

if(WIN32)
    list(APPEND SOURCES osdialog_win.c)
elseif(APPLE)
    list(APPEND SOURCES osdialog_mac.m)
elseif(UNIX)
    list(APPEND SOURCES osdialog_gtk3.c)
else()
    message(FATAL_ERROR "Cannot detect your system")
endif()

add_library(osdialog STATIC "${SOURCES}")
add_executable(osdialog_test ${SOURCES} test.c)

if(MSVC)
	target_compile_options(osdialog PUBLIC -MP -W4 -WX /utf-8 -wd4996)
	target_compile_options(osdialog_test PUBLIC -MP -W4 /utf-8 -wd4996)
else()
	target_compile_options(osdialog PUBLIC -g -Wall -Wextra -std=c99)
	target_compile_options(osdialog_test PUBLIC -g -Wall -Wextra -std=c99)
endif()
if(WIN32)
    target_link_libraries(osdialog comdlg32)
elseif(APPLE)
    target_link_libraries(osdialog "-framework AppKit")
    target_link_libraries(osdialog_test "-framework AppKit")
    target_compile_options(osdialog PUBLIC)
    target_compile_options(osdialog_test PUBLIC)
elseif(UNIX)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(GTK3 "gtk+-3.0")
    if (GTK3_FOUND)
        INCLUDE_DIRECTORIES(${GTK3_INCLUDE_DIRS})
        message("GTK3_INCLUDE_DIRS = ${GTK3_INCLUDE_DIRS}")
        LINK_DIRECTORIES(${GTK3_LIBRARY_DIRS})
        message("GTK3_LIBRARY_DIRS = ${GTK3_LIBRARY_DIRS}")
        target_link_libraries(osdialog ${GTK3_LIBRARIES})
        target_link_libraries(osdialog_test ${GTK3_LIBRARIES})
        message("GTK3_LIBRARIES = ${GTK3_LIBRARIES}")
        add_definitions(${GTK3_CFLAGS} ${GTK3_CFLAGS_OTHER})
        message("GTK3_CFLAGS = ${GTK3_CFLAGS}")
        message("GTK3_CFLAGS_OTHER = ${GTK3_CFLAGS_OTHER}")
    else()
        message(FATAL_ERROR "GTK not found")
    endif()
else()
    message(FATAL_ERROR "Cannot detect your system")
endif()

=== debian/changelog ===
cdogs-sdl (1.3.1-1mx21+1) mx; urgency=medium

  * Rebuild for MX-21

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Tue, 23 Aug 2022 15:06:26 -0700

## cdogs-sdl 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,8 +6,8 @@
 project(cdogs-sdl C)
 
 SET(VERSION_MAJOR "1")
-SET(VERSION_MINOR "3")
-SET(VERSION_PATCH "1")
+SET(VERSION_MINOR "4")
+SET(VERSION_PATCH "0")
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
 # Optionally configure CI files since they are excluded in source archives

=== debian/changelog ===
cdogs-sdl (1.4.0-1mx21+1) mx; urgency=medium

  * Rebuild for MX-21.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 20 Nov 2022 10:30:40 -0800

## cdogs-sdl 1.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 SET(VERSION_MAJOR "1")
 SET(VERSION_MINOR "4")
-SET(VERSION_PATCH "0")
+SET(VERSION_PATCH "1")
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
 # Optionally configure CI files since they are excluded in source archives
@@ -95,6 +95,9 @@
 
 if(MSVC)
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -MP -W4 -WX -wd\"4996\" -wd\"4204\"")
+	if(DEBUG)
+		ADD_DEFINITIONS(-ZI)
+	endif()
 else()
 	add_definitions(
 		-fsigned-char

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -17,12 +17,14 @@
 add_subdirectory(tests)
 
 set(CDOGS_SDL_SOURCES
+	ammo_menu.c
 	animated_counter.c
 	autosave.c
 	briefing_screens.c
 	cdogs.c
 	command_line.c
 	credits.c
+	equip_menu.c
 	game.c
 	game_loop.c
 	hiscores.c
@@ -38,11 +40,13 @@
 	screens_end.c
 	weapon_menu.c)
 set(CDOGS_SDL_HEADERS
+	ammo_menu.h
 	animated_counter.h
 	autosave.h
 	briefing_screens.h
 	command_line.h
 	credits.h
+	equip_menu.h
 	game.h
 	game_loop.h
 	hiscores.h

=== src/cdogsed/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-add_subdirectory(osdialog)
 include_directories(
 	${SDL2_INCLUDE_DIRS}
 	${SDL2_IMAGE_INCLUDE_DIRS}
@@ -19,6 +18,7 @@
 	editor_ui_static_additem.c
 	editor_ui_weapons.c
 	exit_brush.c
+	file_dialog.c
 	mission_options.c
 	nk_window.c
 	tile_brush.c
@@ -39,10 +39,10 @@
 	editor_ui_static_additem.h
 	editor_ui_weapons.h
 	exit_brush.h
+	file_dialog.h
 	mission_options.h
 	nk_window.h
 	tile_brush.h
 	ui_object.h)
 add_library(cdogsedlib STATIC ${CDOGSED_SOURCES} ${CDOGSED_HEADERS})
-target_link_libraries(cdogsedlib
-	${SDL2_LIBRARY} osdialog)
+target_link_libraries(cdogsedlib ${SDL2_LIBRARY})

=== src/tests/CMakeLists.txt ===
if(MSVC)
	add_definitions(-wd"4127" -wd"4102")
else()
	if(NOT BEOS AND NOT HAIKU)
		add_definitions(-Wno-unused-label)
		set(EXTRA_LIBRARIES "m")
	endif()
endif()

add_subdirectory(cbehave)

include_directories(
	. ../cdogs
	${SDL2_INCLUDE_DIRS}
	${SDL2_IMAGE_INCLUDE_DIRS}
	${SDL2_MIXER_INCLUDE_DIRS})

add_executable(animated_counter_test
	animated_counter_test.c
	../animated_counter.h
	../animated_counter.c)
target_link_libraries(animated_counter_test
	cbehave
	cdogs
	cdogs_proto
	${SDL2_LIBRARY}
	${EXTRA_LIBRARIES})
add_test(NAME animated_counter_test COMMAND animated_counter_test)

add_executable(autosave_test
	autosave_test.c
	../autosave.h
	../autosave.c)
target_link_libraries(autosave_test
	cbehave
	cdogs
	cdogs_proto
	${SDL2_LIBRARY}
	${EXTRA_LIBRARIES})
add_test(NAME autosave_test COMMAND autosave_test)

add_executable(c_hashmap_test
	c_hashmap_test.c
	../cdogs/c_hashmap/hashmap.h
	../cdogs/c_hashmap/hashmap.c)
target_link_libraries(c_hashmap_test cbehave ${EXTRA_LIBRARIES})
add_test(NAME c_hashmap_test COMMAND c_hashmap_test)

add_executable(c_array_test
	c_array_test.c
	../cdogs/c_array.h
	../cdogs/c_array.c)
target_link_libraries(c_array_test
	cbehave ${EXTRA_LIBRARIES})
add_test(NAME c_array_test COMMAND c_array_test)

add_executable(color_test
	color_test.c
	../cdogs/color.c
	../cdogs/color.h)
target_link_libraries(color_test cbehave ${EXTRA_LIBRARIES})
add_test(NAME color_test COMMAND color_test)

add_executable(config_test config_test.c)
target_link_libraries(config_test
	cbehave
	cdogs
	cdogs_proto
	${SDL2_LIBRARY}
	${EXTRA_LIBRARIES})
add_test(NAME config_test COMMAND config_test)

add_executable(json_test json_test.c)
target_link_libraries(json_test
	cbehave
	cdogs
	cdogs_proto
	${SDL2_LIBRARY}
	${EXTRA_LIBRARIES})
add_test(NAME json_test COMMAND json_test)

add_executable(minkowski_hex_test minkowski_hex_test.c)
target_link_libraries(minkowski_hex_test
	cbehave
	cdogs
	cdogs_proto
	${SDL2_LIBRARY}
	${EXTRA_LIBRARIES})
add_test(NAME minkowski_hex_test COMMAND minkowski_hex_test)

add_executable(pic_test pic_test.c)
target_link_libraries(pic_test
	cbehave
	cdogs
	cdogs_proto
	${SDL2_LIBRARY}
	${SDL2_IMAGE_LIBRARIES}
	${EXTRA_LIBRARIES})
# TODO: test disabled since Travis-CI fails with "No available video device"
#add_test(NAME pic_test COMMAND pic_test)

add_executable(player_test player_test.c)
target_link_libraries(player_test
	cbehave
	cdogs
	cdogs_proto
	${SDL2_LIBRARY}
	${EXTRA_LIBRARIES})
add_test(NAME player_test COMMAND player_test)

add_executable(utils_test utils_test.c)
target_link_libraries(utils_test
	cbehave
	cdogs
	cdogs_proto
	${SDL2_LIBRARY} ${EXTRA_LIBRARIES})
add_test(NAME utils_test COMMAND utils_test)

=== src/cdogs/yajl/CMakeLists.txt ===
# Copyright (c) 2007-2014, Lloyd Hilaiel <me@lloyd.io>
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

SET (YAJL_MAJOR 2)
SET (YAJL_MINOR 1)
SET (YAJL_MICRO 1)

SET (SRCS yajl.c yajl_lex.c yajl_parser.c yajl_buf.c
          yajl_encode.c yajl_gen.c yajl_alloc.c
          yajl_tree.c yajl_version.c
)
SET (HDRS yajl_parser.h yajl_lex.h yajl_buf.h yajl_encode.h yajl_alloc.h)
SET (PUB_HDRS api/yajl_parse.h api/yajl_gen.h api/yajl_common.h api/yajl_tree.h)

# useful when fixing lexer bugs.
#ADD_DEFINITIONS(-DYAJL_LEXER_DEBUG)

# Ensure defined when building YAJL (as opposed to using it from
# another project).  Used to ensure correct function export when
# building win32 DLL.
ADD_DEFINITIONS(-DYAJL_BUILD)

# set up some paths
SET (libDir ${CMAKE_CURRENT_BINARY_DIR}/../${YAJL_DIST_NAME}/lib)
SET (incDir ${CMAKE_CURRENT_BINARY_DIR}/../${YAJL_DIST_NAME}/include/yajl)
SET (shareDir ${CMAKE_CURRENT_BINARY_DIR}/../${YAJL_DIST_NAME}/share/pkgconfig)

# set the output path for libraries
SET(LIBRARY_OUTPUT_PATH ${libDir})

ADD_LIBRARY(yajl_s STATIC ${SRCS} ${HDRS} ${PUB_HDRS})

ADD_LIBRARY(yajl SHARED ${SRCS} ${HDRS} ${PUB_HDRS})

#### setup shared library version number
SET_TARGET_PROPERTIES(yajl PROPERTIES
                      DEFINE_SYMBOL YAJL_SHARED
                      SOVERSION ${YAJL_MAJOR}
                      VERSION ${YAJL_MAJOR}.${YAJL_MINOR}.${YAJL_MICRO})

#### ensure a .dylib has correct absolute installation paths upon installation
IF(APPLE)
  SET_TARGET_PROPERTIES(yajl PROPERTIES
                        INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
ENDIF(APPLE)

#### build up an sdk as a post build step

# create some directories
FILE(MAKE_DIRECTORY ${libDir})
FILE(MAKE_DIRECTORY ${incDir})

# generate build-time source
SET(dollar $)
CONFIGURE_FILE(api/yajl_version.h.cmake ${incDir}/yajl_version.h)
CONFIGURE_FILE(yajl.pc.cmake ${shareDir}/yajl.pc)

# copy public headers to output directory
FOREACH (header ${PUB_HDRS})
  SET (header ${CMAKE_CURRENT_SOURCE_DIR}/${header})

  EXEC_PROGRAM(${CMAKE_COMMAND} ARGS -E copy_if_different ${header} ${incDir})

  ADD_CUSTOM_COMMAND(TARGET yajl_s POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy_if_different ${header} ${incDir})
ENDFOREACH (header ${PUB_HDRS})

INCLUDE_DIRECTORIES(${incDir}/..)

=== debian/changelog ===
cdogs-sdl (1.4.1-1mx21+1) mx; urgency=medium

  * Rebuild for MX-21.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 12 Mar 2023 07:31:11 -0700

=== debian/control ===
Source: cdogs-sdl
Section: games
Priority: optional
Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
XSBC-Original-Maintainer: Christoph Korn <christoph.korn@getdeb.net>
Build-Depends: debhelper (>= 10),
               build-essential, 
               cmake (>=3.0.2),
               libsdl2-dev (>=2.0.4),
               libsdl2-image-dev (>=2),
               libjsoncpp-dev (>=0.6),
               libreadline-dev (>=7.0) | libreadline6-dev (>=6.3),
               libphysfs-dev (>=2.0),
               libsdl2-mixer-dev (>=2.0),
               libenet-dev (>=1.3.12),
               libgtk-3-dev
Standards-Version: 3.9.7
Homepage: http://cxong.github.io/cdogs-sdl/

Package: cdogs-sdl
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         cdogs-sdl-data (= ${source:Version})
Description: Open source, classic overhead run-and-gun game
 C-Dogs SDL is a classic overhead run-and-gun game,
 supporting up to 4 players in co-op and deathmatch modes.
 Customize your player, choose from up to 11 weapons, and
 try the dozens of user-created campaigns. Have fun!

Package: cdogs-sdl-data
Architecture: all
Depends: ${misc:Depends}
Description: Open source, classic overhead run-and-gun game (data package)
 C-Dogs SDL is a classic overhead run-and-gun game,
 supporting up to 4 players in co-op and deathmatch modes.
 Customize your player, choose from up to 11 weapons, and
 try the dozens of user-created campaigns. Have fun!
 .
 (This package contains the data files).

=== debian/rules ===
#!/usr/bin/make -f
PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
PKG   = $(shell dpkg-parsechangelog -l$(PKD)/changelog -SSource)
VER  = $(shell dpkg-parsechangelog -l$(PKD)/changelog -SVersion | cut -d- -f1)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr/ -DCDOGS_DATA_DIR=./

override_dh_install:
	dh_install
	rm -f debian/cdogs-sdl-data/usr/share/games/cdogs/doc/COPYING.*
	rm -f debian/cdogs-sdl-data/usr/share/games/cdogs/doc/LICENSE.*
	rm -f debian/cdogs-sdl-data/usr/share/games/cdogs/doc/license.rlutil.txt
	rm -f debian/cdogs-sdl-data/usr/share/games/cdogs/graphics/LICENSE.md
	rm -f debian/cdogs-sdl-data/usr/share/games/cdogs/missions/sauer2/LICENSE.txt
	rm -f debian/cdogs-sdl-data/usr/share/games/cdogs/sounds/footsteps/license.txt
	[ ! -f debian/cdogs-sdl-data/usr/share/games/cdogs/graphics/make_bullet_spritesheet.sh ] || \
	    chmod +x debian/cdogs-sdl-data/usr/share/games/cdogs/graphics/make_bullet_spritesheet.sh

## http://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER).orig.tar.xz $(info I: $(PKG)_$(VER))
	@

## checkout from git (add "git" to Build-Depends)
UURL = git://github.com/cxong/cdogs-sdl
$(PKG)_$(VER).orig.tar.xz:
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(VER) \
	|| $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
	&& git checkout $(VER) \
	&& git submodule init \
	&& git submodule update --init --recursive \
	&& git submodule update --recursive \
	&& [ -s ChangeLog ] || ( echo "# Generating ChangeLog..." \
	   ; git log --pretty="format:%ad  %aN  <%aE>%n%n%x09* %s%n" --date=short > ChangeLog \
	   ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
	&& echo "# Setting times..." \
	&& git ls-tree -r --name-only HEAD | while read F ; do touch --no-dereference -d "$$(git log -1 --format="%ai" -- "$$F")" "$$F"; done \
	&& $(RM) -r .git .git*
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	| XZ_OPT="-6v" tar -caf "$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	&& $(RM) -r "$(PKG)-$(VER)"

override_dh_strip:
	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=3
https://github.com/cxong/cdogs-sdl/releases \
    (?:.*/)?archive/([\d\.]+)\.tar\.gz

## cdogs-sdl 2.0.0

=== src/cdogs/enet/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
cmake_policy(SET CMP0054 NEW)

project(enet)

# The "configure" step.
include(CheckFunctionExists)
include(CheckStructHasMember)
include(CheckTypeSize)
check_function_exists("fcntl" HAS_FCNTL)
check_function_exists("poll" HAS_POLL)
check_function_exists("getaddrinfo" HAS_GETADDRINFO)
check_function_exists("getnameinfo" HAS_GETNAMEINFO)
check_function_exists("gethostbyname_r" HAS_GETHOSTBYNAME_R)
check_function_exists("gethostbyaddr_r" HAS_GETHOSTBYADDR_R)
check_function_exists("inet_pton" HAS_INET_PTON)
check_function_exists("inet_ntop" HAS_INET_NTOP)
check_struct_has_member("struct msghdr" "msg_flags" "sys/types.h;sys/socket.h" HAS_MSGHDR_FLAGS)
set(CMAKE_EXTRA_INCLUDE_FILES "sys/types.h" "sys/socket.h")
check_type_size("socklen_t" HAS_SOCKLEN_T BUILTIN_TYPES_ONLY)
unset(CMAKE_EXTRA_INCLUDE_FILES)
if(MSVC)
	add_definitions(-W3)
else()
	add_definitions(-Wno-error)
endif()
 
if(HAS_FCNTL)
    add_definitions(-DHAS_FCNTL=1)
endif()
if(HAS_POLL)
    add_definitions(-DHAS_POLL=1)
endif()
if(HAS_GETNAMEINFO)
    add_definitions(-DHAS_GETNAMEINFO=1)
endif()
if(HAS_GETADDRINFO)
    add_definitions(-DHAS_GETADDRINFO=1)
endif()
if(HAS_GETHOSTBYNAME_R)
    add_definitions(-DHAS_GETHOSTBYNAME_R=1)
endif()
if(HAS_GETHOSTBYADDR_R)
    add_definitions(-DHAS_GETHOSTBYADDR_R=1)
endif()
if(HAS_INET_PTON)
    add_definitions(-DHAS_INET_PTON=1)
endif()
if(HAS_INET_NTOP)
    add_definitions(-DHAS_INET_NTOP=1)
endif()
if(HAS_MSGHDR_FLAGS)
    add_definitions(-DHAS_MSGHDR_FLAGS=1)
endif()
if(HAS_SOCKLEN_T)
    add_definitions(-DHAS_SOCKLEN_T=1)
endif()
 
include_directories(${PROJECT_SOURCE_DIR}/include)
 
add_library(enet STATIC
        callbacks.c
        compress.c
        host.c
        list.c
        packet.c
        peer.c
        protocol.c
        unix.c
        win32.c
    )

=== debian/changelog ===
cdogs-sdl (2.0.0-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 23 Feb 2024 14:15:40 -0800

cdogs-sdl (1.5.0+dfsg-1) unstable; urgency=low

  * Initial packaging (Closes: #1040944).

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 12 Feb 2024 19:06:46 +0100

=== debian/control ===
Source: cdogs-sdl
Section: games
Priority: optional
Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Reiner Herrmann <reiner@reiner-h.de>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libenet-dev,
               libnanopb-dev (>= 0.4.8-1~),
               libsdl2-dev,
               libsdl2-image-dev,
               libsdl2-mixer-dev,
               nanopb
Standards-Version: 4.6.2
Homepage: https://cxong.github.io/cdogs-sdl/
Vcs-Git: https://salsa.debian.org/games-team/cdogs-sdl.git
Vcs-Browser: https://salsa.debian.org/games-team/cdogs-sdl
Rules-Requires-Root: no

Package: cdogs-sdl
Architecture: any
Built-Using: ${Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends}, cdogs-sdl-data (= ${source:Version})
Description: classic overhead run-and-gun game
 C-Dogs SDL is an overhead shoot-em-up which lets players work alone and
 cooperatively during missions or fight against each other in the
 "dogfight" deathmatch mode.
 .
 Customize your player, choose from many weapons, and blast, slide and
 slash your way through over 100 user-created campaigns.

Package: cdogs-sdl-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: classic overhead run-and-gun game - data files
 C-Dogs SDL is an overhead shoot-em-up which lets players work alone and
 cooperatively during missions or fight against each other in the
 "dogfight" deathmatch mode.
 .
 Customize your player, choose from many weapons, and blast, slide and
 slash your way through over 100 user-created campaigns.
 .
 This package contains the data files for C-Dogs SDL.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# nanopb headers are in /usr/include/nanopb, but generated msg.pb.h
# header includes <pb.h>
export DEB_CPPFLAGS_MAINT_APPEND = -I/usr/include/nanopb

%:
	dh $@

src/proto/msg.pb: src/proto/msg.proto
	cd src/proto && protoc -omsg.pb msg.proto

src/proto/msg.pb.c src/proto/msg.pb.h &: src/proto/msg.pb
	cd src/proto && nanopb_generator.py msg.pb

override_dh_auto_configure: src/proto/msg.pb.c src/proto/msg.pb.h
	dh_auto_configure -- \
		-DCDOGS_BIN_DIR=/usr/games \
		-DCDOGS_DATA_DIR=/usr/share/games/cdogs-sdl/ \
		-DUSE_SHARED_ENET=ON \
		-DDEBUG=ON \
		-DBUILD_EDITOR=OFF

execute_before_dh_installdocs:
	rm -r $(CURDIR)/debian/tmp/usr/doc

execute_before_dh_install:
	find $(CURDIR)/debian/tmp -type f '(' -iname "LICENSE.md" -o -iname "README.md" -o -name "*.sh" ')' -delete
	# delete txt files (containing only license/copyright information), except a few important ones
	find $(CURDIR)/debian/tmp -type f '(' -name "*.txt" -a '!' \
		'(' -name 'gamecontroller*db.txt' -o -name 'prefixes.txt' -o -name 'suffix*.txt' ')' ')' -delete

override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libnanopb-dev")"

override_dh_strip:
	dh_strip -a --no-automatic-dbgsym
